//--------------------------------------------------------------
// $Source: /rcs/crcs/general/intel/vcatalog.hh,v $
// Checked in by: $Author: andrews $
// $Date: 1996/04/15 22:48:31 $             $Revision: 1.10 $
//--------------------------------------------------------------
//         Copyright(c) 1994, Visual Edge Software Ltd.
//
// ALL RIGHTS RESERVED. This notice is intended as a precaution
// against inadvertent publication, and shall not be deemed to
// consitute an acknowledgment that publication has occurred
// nor to imply any waiver of confidentiality. The year included
// in the notice is the year of the creation of the work.
//--------------------------------------------------------------
// DESCRIPTION:
//      This file contains the implementation for the
//      VCatMsg class. The VeCatalog class implements
//      a message catalog utility that should be used for all
//      internal warning, status, and error messages.
//--------------------------------------------------------------

/* Copyright (c) International Business Machines Inc, 1994 */

#ifndef VCATALOG_H
#define VCATALOG_H

#include <os.h>		// for VSYS_WINDOWS
#include <dllclass.hh>	// for VeDllBasedClass
#include <vtoolkit.hh>
#include <vstring.hh>	// for VeString

#ifdef _OS2
#define INCL_PM
#define INCL_DOS
#include <os2.h>          //included by vwtoolkt
#define HINSTANCE void *
#else
#include <vtoolkit.hh>

#endif

#define VPASTE(token1,token2)            token1##token2

/*------------------------------------------------------------------------
 * Convenience macro:
 * instead of           catalog.GetMsg (MS_MSGID, DS_MS_MSGID)
 * you can say          catalog.VGETMSG (MSGID);
 *------------------------------------------------------------------------*/

#define VGETMSG(msgid) \
        GetMsg(VPASTE (MS_,msgid), VPASTE(DS_MS_,msgid))


VCLASS VeCatalog : public VeDllBasedClass
{
        public:

                VOPERDECL 		VeCatalog( const char* catname, 
						  int msgset=0,
						  VHInstance anInstance=0 );

                virtual VOPERDECL 	~VeCatalog ();

                VVIRTUALDECL(VeString) 	GetMsg (int msgid, char *aMsg=0);

                static VMETHODDECL(void) CloseAll ();     // No catalog can be used after this!
		static VMETHODDECL(void) InitPath (VeString aPath);

        private:
                VeString        itsName;
                int             isAvailable;

		VHInstance	itsLocalInst;
                VHInstance	itsExternInst;

		static VeString ThePath;
};

#endif //VCATALOG_H
